> ## Documentation Index
> Fetch the complete documentation index at: https://docs.forge.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create MCP approval

> Create MCP server approval requests with requested subjects, agents, and optional scanner kickoff.



## OpenAPI

````yaml /openapi/forge-api.yaml post /api/headless/v1/organizations/{organizationId}/approvals/mcp
openapi: 3.0.3
info:
  title: Forge API
  version: 0.1.0
  description: >-
    Automate Forge inventory, investigations, findings, governance, fleet,
    policy, configuration, compliance, MCP, service-account, and audit
    workflows.
servers:
  - url: https://api.forge.ai
    description: Forge production API
security:
  - serviceAccountBearer: []
tags:
  - name: approvals
    description: MCP approvals
  - name: audit
    description: Audit
  - name: capabilities
    description: Capabilities
  - name: compliance
    description: Compliance
  - name: findings
    description: Findings
  - name: fleet
    description: Fleet
  - name: governance
    description: Governance
  - name: inventory
    description: Inventory
  - name: investigation
    description: Investigations
  - name: managed-config
    description: Managed configuration
  - name: mcp
    description: MCP sessions
  - name: mcp-registry
    description: MCP and skill registry
  - name: operations
    description: operations
  - name: policies
    description: Policies and violations
  - name: service-accounts
    description: Service accounts
  - name: settings
    description: Automation settings
paths:
  /api/headless/v1/organizations/{organizationId}/approvals/mcp:
    post:
      tags:
        - approvals
      summary: Create MCP approval
      description: >-
        Create MCP server approval requests with requested subjects, agents, and
        optional scanner kickoff.
      operationId: createHeadlessMcpApproval
      parameters:
        - $ref: '#/components/parameters/OrganizationId'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              additionalProperties: true
              required:
                - businessUseCase
                - reason
                - idempotencyKey
                - confirm
              anyOf:
                - required:
                    - mcpServerId
                - required:
                    - registryItemId
                - required:
                    - proposedServer
              properties:
                mcpServerId:
                  type: string
                registryItemId:
                  type: string
                proposedServer:
                  type: object
                  additionalProperties: false
                  required:
                    - name
                    - locator
                  properties:
                    name:
                      type: string
                    locator:
                      type: string
                      format: uri
                    transport:
                      type: string
                      enum:
                        - streamable_http
                        - http
                        - sse
                businessUseCase:
                  type: string
                urgency:
                  type: string
                targetApp:
                  type: string
                targetProjectRef:
                  type: string
                targetTeam:
                  type: string
                requestedExpiryAt:
                  type: string
                  format: date-time
                requestedSubjects:
                  type: array
                  items:
                    type: object
                    additionalProperties: false
                    required:
                      - subjectKind
                    properties:
                      subjectKind:
                        type: string
                      directoryUserId:
                        type: string
                      directoryGroupId:
                        type: string
                      teamRef:
                        type: string
                requestedAgents:
                  type: array
                  items:
                    type: object
                    additionalProperties: false
                    properties:
                      sourceAdapterKey:
                        type: string
                      agentId:
                        type: string
                      appRef:
                        type: string
                runScannerNow:
                  type: boolean
                reason:
                  type: string
                idempotencyKey:
                  type: string
                confirm:
                  type: boolean
      responses:
        '201':
          description: Created MCP approval request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HeadlessProxyResponse'
        '400':
          $ref: '#/components/responses/Error'
        '401':
          $ref: '#/components/responses/Error'
        '403':
          $ref: '#/components/responses/Error'
components:
  parameters:
    OrganizationId:
      name: organizationId
      in: path
      required: true
      schema:
        type: string
  schemas:
    HeadlessProxyResponse:
      type: object
      additionalProperties: true
    MessageResponse:
      type: object
      required:
        - message
      properties:
        message:
          type: string
  responses:
    Error:
      description: Stable Forge error envelope.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/MessageResponse'
  securitySchemes:
    serviceAccountBearer:
      type: http
      scheme: bearer
      bearerFormat: Forge service-account or delegated OAuth access token
      description: >-
        Enter a Forge service-account token or delegated OAuth access token.
        Mintlify adds the Bearer prefix.

````